#version 120

uniform vec3 cameraPosition;
uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform int fogMode;
uniform int worldTime;
uniform int isEyeInWater;
uniform float rainStrength;
uniform float wetness;
uniform float far;
uniform float near;
uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;
uniform mat4 shadowProjection;
uniform mat4 shadowProjectionInverse;
uniform mat4 shadowModelView;
uniform mat4 shadowModelViewInverse;
uniform float viewWidth;
uniform float viewHeight;
uniform float aspectRatio;
uniform float sunAngle;
uniform float moonAngle;
const int GL_LINEAR = 9729;
const int GL_EXP = 2048;
uniform sampler2D texture;
uniform sampler2D normals;
uniform sampler2D specular;
uniform sampler2D lightmap;
varying vec4 texcoord;
varying vec4 lmcoord;
varying vec3 tangent;
varying vec3 normal;
varying vec3 binormal;
varying vec3 viewVector;
varying vec4 color;
varying float distance;
varying float iswater;
varying float sprite;
varying float test;
const int linear_steps = 18;
const int binary_steps = 6;
const float bump_distance = 60.0;
const float pom_distance = 30.0;
const float fademult = 0.1;
const float texinterval = 0.0625;
const float pom_depth = 0.1;
float pack(float m, float d){
   return clamp(ceil(m)/10 + clamp(d, 0.0, 0.9999f)*.1, 0.0, 0.99999f);
}
float fad(float val){
    return clamp(floor(val*100.0)*.01, 0.0, .99);
}
float lmp(vec2 lmc){
    return fad(lmc.s) + fad(lmc.t)*.01;
}

void main(){
    gl_FragDepth = gl_FragCoord.z;
    vec3 coord = vec3(texcoord.st, 1.0);
    vec4 colored = texture2D(texture, coord.st)* color;
    colored.rgb *= texture2D(lightmap, lmcoord.st).rgb;
    gl_FragData[0] = colored;
    gl_FragData[1] = vec4(pack(0, gl_FragDepth), lmp(lmcoord.st), 1.0, 1.0);
    gl_FragData[2] = vec4(normal * 0.5 + 0.5, 1.0);
    gl_FragData[7] = gl_FragData[3] = vec4(0.0);
    gl_FragData[4] = vec4(pack(2, 0.0), 0.0, 0.0, 1.0);
}   