#version 120

attribute vec4 mc_Entity;
attribute vec3 tanget;

uniform sampler2D texture;
uniform sampler2D normals;
uniform sampler2D specular;
uniform sampler2D lightmap;
varying vec4 texcoord;
varying vec4 lmcoord;
varying vec3 tangent;
varying vec3 normal;
varying vec3 binormal;
varying vec3 viewVector;
varying vec4 color;
varying float distance;
varying float iswater;
varying float sprite;
varying float test;
const int linear_steps = 18;
const int binary_steps = 6;
const float bump_distance = 60.0;
const float pom_distance = 30.0;
const float fademult = 0.1;
const float texinterval = 0.0625;
const float pom_depth = 0.1;
float pack(float m, float d){
   return clamp(ceil(m)/10 + clamp(d, 0.0, 0.9999f)*.1, 0.0, 0.99999f);
}
float fad(float val){
    return clamp(floor(val*100.0)*.01, 0.0, .99);
}
float lmp(vec2 lmc){
    return fad(lmc.s) + fad(lmc.t)*.01;
}

void main(){
  vec4 locposition = gl_ModelViewMatrix * gl_Vertex;
  distance = sqrt(locposition.x * locposition.x + locposition.y * locposition.y + locposition.z * locposition.z);
  color = gl_Color;
  texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;
  lmcoord = gl_TextureMatrix[1] * gl_MultiTexCoord1;
  gl_Position = ftransform();
  gl_FogFragCoord = gl_Position.z;
}